/**
 * Copyright (c) 2015-2017 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.cli.base.junit.rules;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;

import org.junit.rules.ExternalResource;

/**
 * This was implemented because TextFromStandardInputStream from system-rules
 * (http://stefanbirkner.github.io/system-rules/) does not seem to not work with JLine that we use in petals cli...
 * 
 * @author Victor Noel
 *
 */
public class ConsoleInput extends ExternalResource {

    private InputStream standardConsoleInput;

    private OutputStream consoleInput;

    public void writeLine(final String line) throws IOException {
        this.consoleInput.write(String.format("%s%n", line).getBytes());
        this.consoleInput.flush();
    }

    @Override
    protected void before() throws Exception {
        this.standardConsoleInput = System.in;
        final PipedOutputStream pos = new PipedOutputStream();
        this.consoleInput = pos;
        System.setIn(new PipedInputStream(pos));
    }

    @Override
    protected void after() {
        System.setIn(this.standardConsoleInput);
        this.standardConsoleInput = null;
        this.consoleInput = null;
    }
}
